#ifndef TEXTLOGREADER_HPP
#define TEXTLOGREADER_HPP

#include "ExtendedLog_global.h"
#include "LogReader.hpp"

#include <QString>

namespace ExtendedLog
{
	/**
	 * @brief Class for reading from text-based log-files
	 */
	class EXTENDEDLOG_EXPORT TextLogReader : public LogReader
	{
		public:
			/**
			 * @brief Create a new text-based log-reader
			 * @param filename The file to read from
			 */
			TextLogReader(QString filename);
	
		protected:
			/**
			 * @brief Read all entries from file
			 */
			void readAllEntries() override;
	};
} // namespace ExtendedLog

#endif // TEXTLOGREADER_HPP
