#include "MultipleLogWriter.hpp"

ExtendedLog::MultipleLogWriter::MultipleLogWriter()
{ }

void ExtendedLog::MultipleLogWriter::addWriter(LogWriter &logWriter)
{
	this->logWriters.push_back(&logWriter);
}

bool ExtendedLog::MultipleLogWriter::removeWriter(LogWriter &logWriter)
{
	return this->logWriters.removeOne(&logWriter);
}

void ExtendedLog::MultipleLogWriter::writeEntry(EntryType type, QString message)
{
	for (LogWriter *writer : qAsConst(this->logWriters))
	{
		writer->writeEntry(type, message);
	}
	
}

void ExtendedLog::MultipleLogWriter::close()
{
	for (LogWriter *writer : qAsConst(this->logWriters))
	{
		writer->close();
	}
}
