#include "EntryType.hpp"
#include "TextLogReader.hpp"

#include <QFile>
#include <QString>
#include <QStringList>
#include <QTextStream>
#include <QVector>

ExtendedLog::TextLogReader::TextLogReader(QString filename): LogReader(filename)
{
	readAllEntries();
}

void ExtendedLog::TextLogReader::readAllEntries()
{
	QFile file(this->filename);
	if (!file.open(QIODevice::ReadOnly)) { return; }

	QTextStream inStream(&file);
    inStream.setCodec("UTF-8");
	while (!inStream.atEnd())
	{
		QString line = inStream.readLine();
		QStringList entryValues = line.split(" : ");
		//bool entryOk;
		switch (entryValues.count())
		{
			case 1:
			{
				LogEntry entryCaseOne = LogEntry(EntryType::UNKNOWN, entryValues[0]);
				this->allEntries.push_back(entryCaseOne);
				break;
			}
			case 2:
			{
				LogEntry entryCaseTwo = LogEntry(EntryType::UNKNOWN, entryValues[0]);
				if (!entryCaseTwo.trySetDateTime(entryValues[1])) { entryCaseTwo.setEntryType(entryValues[1]); }
				this->allEntries.push_back(entryCaseTwo);
				break;
			}
			case 3:
			{
				LogEntry entryCaseThree = LogEntry(entryValues[0], entryValues[1], entryValues[2]);
				this->allEntries.push_back(entryCaseThree);
				break;
			}
			default:
				break;
		}
	}
	file.close();
}
