#include "XmlLogReader.hpp"

ExtendedLog::XmlLogReader::XmlLogReader(QString filename) :
	LogReader(filename),
	inputFile(filename),
	logReader(&inputFile)
{
	if (!inputFile.open(QIODevice::ReadOnly)) { throw false; }
	else { readAllEntries(); }
}

void ExtendedLog::XmlLogReader::readAllEntries()
{
	Q_ASSERT(logReader.isStartElement() && logReader.name() == "logfile");

	while (logReader.readNextStartElement())
	{
		if (logReader.name() == "entry") { readNextEntry(); }
		else { logReader.skipCurrentElement(); }
	}
	logReader.clear();
	inputFile.close();
}

void ExtendedLog::XmlLogReader::readNextEntry()
{
	QString entryContent[3] = {"", "", ""};

	while (logReader.readNextStartElement())
	{
		if (logReader.name() == "datetime")
		{
			entryContent[0] = logReader.readElementText();
		}
		else if (logReader.name() == "type")
		{
			entryContent[1] = logReader.readElementText();
		}
		else if (logReader.name() == "message")
		{
			entryContent[2] = logReader.readElementText();
		}
		else
		{
			logReader.skipCurrentElement();
		}
		LogEntry entry(entryContent[0], entryContent[1], entryContent[2]);
		this->allEntries.push_back(entry);
	}
}
